<?php

/**
  * Translations tab for admin panel, AdminTranslationsErrors.php
  * @category admin
  *
  * @author PrestaShop <support@prestashop.com>
  * @copyright PrestaShop
  * @license http://www.opensource.org/licenses/osl-3.0.php Open-source licence 3.0
  * @version 0.8
  *
  */

class AdminTranslationsErrors extends AdminTab
{
	public function postProcess()
	{
		global $currentIndex;
	
		if (Tools::getValue('submitTranslations'))
		{
		 	/* Create a new language file */
			if ($fd = fopen(_PS_ERRORS_DIR_.strtolower(Tools::getValue('lang')).'.php', 'w'))
			{
				unset($_POST['submitTranslations']);
				unset($_POST['lang']);
				$toInsert = array();
				foreach($_POST as $key => $value)
					if (!empty($value))
						$toInsert[$key] = pSQL($value);
				fwrite($fd, "<?php\n\nglobal \$_ERRORS;\n\$_ERRORS = array();\n");
				foreach($toInsert as $key => $value)
					fwrite($fd, '$_ERRORS[\''.$key.'\'] = \''.$value.'\';'."\n");
				fwrite($fd, "\n?>");
				Tools::redirectAdmin($currentIndex.'&conf=4');
			}
			else
				die('Cannot write language file');
		}
		elseif (isset($_GET['lang']))
			$this->displayForm();
	}
	
	public function display()
	{
		global $currentIndex;
		
		if (!isset($_GET['lang']))
		{
			echo $this->l('Please select a language by clicking on the corresponding flag').'.<br /><br />';
			$languages = Language::getLanguages();
			if (sizeof($languages) == 1)
				Tools::redirectLink($currentIndex.'&lang='.$languages[0]['iso_code']);
			foreach ($languages as $language)
				echo '<a href="'.$currentIndex.'&lang='.$language['iso_code'].'" >
						<img src="'._THEME_LANG_DIR_.'/'.$language['id_lang'].'.jpg" alt="'.$language['iso_code'].'" title="'.$language['iso_code'].'" />
					</a> ';
		}
	}
	
	function displayForm()
	{
		global $currentIndex;
		
		$lang = Tools::getValue('lang');
		$_ERRORS = array();
		@include(_PS_ERRORS_DIR_.strtolower($lang).'.php');
		
		/* List files to parse */
		$stringToTranslate = array();
		$dirToParse = array('', 'classes/', 'admin/', 'admin/tabs/');
		foreach ($dirToParse AS $dir)
		{
			$files = scandir(dirname(__FILE__).'/../../'.$dir);
			foreach ($files AS $file)
				if (ereg('.php$', $file) AND file_exists($fn = dirname(__FILE__).'/../../'.$dir.$file))
				{
					$fd = fopen($fn, 'r');
					$content = fread($fd, filesize($fn));
					$regex = '/Tools::displayError\(\'(.*)\'\)/U';
					preg_match_all($regex, $content, $matches);
					foreach($matches[1] as $key)
						$stringToTranslate[$key] = (key_exists(md5($key), $_ERRORS)) ? $_ERRORS[md5($key)] : '';
				}
		}
		
		$irow = 0;
		echo '<h2>'.$this->l('Language').' : '.strtoupper($lang).'</h2>'.$this->l('Errors to translate').' : <b>'.sizeof($stringToTranslate).'</b><br /><br /><form method="post" action="'.$currentIndex.'&submitTranslations=1&lang='.$lang.'" class="form"><table cellpadding="0" cellspacing="0" class="table">';
		foreach ($stringToTranslate as $key => $value)
			echo '<tr '.(++$irow % 2 ? 'class="alt_row"' : '').'><td>'.stripslashes($key).'</td><td style="width: 430px">= <input type="text" name="'.md5($key).'" value="'.preg_replace('/"/', '\\"', stripslashes($value)).'" style="width: 400px"></td></tr>';
		echo '</table><br /><input type="submit" name="submitTranslations" value="'.$this->l('Update translations').'" class="button" /></form>';
	}
}

?>