<?php

/**
  * OrderDetail class, OrderDetail.php
  * Orders detail management
  * @category classes
  *
  * @author PrestaShop <support@prestashop.com>
  * @copyright PrestaShop
  * @license http://www.opensource.org/licenses/osl-3.0.php Open-source licence 3.0
  * @version 0.8
  *
  */

class OrderDetail extends ObjectModel
{
	/** @var integer */
	public $id_order_detail;
	
	/** @var integer */
	public $id_order;

	/** @var string */	
	public $product_name;

	/** @var string */	
	public $product_quantity;

	/** @var float */
	public $product_price;
	
	/** @var string */
	public $product_reference;
	
	/** @var float */
	public $product_weight;
	
	/** @var string */
	public $tax_name;

	/** @var float */
	public $tax_rate;

	protected $tables = array ('order_detail');

	protected	$fieldsRequired = array ('id_order', 'product_name', 'product_quantity', 'product_price', 'tax_name', 'tax_rate');
	protected	$fieldsValidate = array ('id_order' => 'isUnsignedId', 'product_name' => 'isGenericName', 'product_quantity' => 'isInt', 'product_price' => 'isPrice',
	'product_reference' => 'isReference', 'product_weight' => 'isFloat', 'tax_name' => 'isGenericName', 'tax_rate' => 'isFloat');	
	
	protected 	$table = 'order_detail';
	protected 	$identifier = 'id_order_detail';
	
	public function getFields()
	{
		parent::validateFields();

		$fields['id_order'] = intval($this->id_order);
		$fields['product_name'] = pSQL($this->product_name);
		$fields['product_quantity'] = intval($this->product_quantity);
		$fields['product_price'] = floatval($this->product_price);
		$fields['product_reference'] = pSQL($this->product_reference);
		$fields['product_weight'] = floatval($this->product_weight);
		$fields['tax_name'] = pSQL($this->tax_name);
		$fields['tax_rate'] = floatval($this->tax_rate);
		
		return $fields;
	}	
}

?>