<?php
function checkRequiredFunctions()
{
	foreach (array('fopen', 'fclose', 'fread', 'fwrite', 'rename', 'move_uploaded_file', 
	'file_exists', 'unlink', 'rmdir', 'mkdir', 'getcwd', 'chdir', 'chmod') AS $function)
		if (!function_exists($function))
			return false;
	return true;
}

$testArray['error']['php_version']['name'] = l('PHP Version must be >= 5.0');
$testArray['error']['php_version']['res'] = version_compare(phpversion(), '5.0', '>=');
$testArray['error']['up_allowed']['name'] = l('File upload must be allowed');
$testArray['error']['up_allowed']['res'] = ini_get('file_uploads');
$testArray['error']['fopen_allowed']['name'] = l('External URL open must be allowed');
$testArray['error']['fopen_allowed']['res'] = ini_get('allow_url_fopen');
$testArray['error']['forbbiden_fct']['name'] = l('Files and directories creation must be allowed');
$testArray['error']['forbbiden_fct']['res'] = checkRequiredFunctions();
$testArray['error']['gd_library']['name'] = l('Graphic library must be installed (GD)');
$testArray['error']['gd_library']['res'] = function_exists('imagecreatetruecolor');

$testArray['perm']['config_dir']['name'] = l('\'config\' directory must be writable');
$testArray['perm']['config_dir']['res'] = is_writable(dirname(__FILE__).'/../../config/');
$testArray['perm']['img_dir']['name'] = l('\'img\' directory and sub-directories must be writable');
$testArray['perm']['img_dir']['res'] = is_writable(dirname(__FILE__).'/../../img/');
$testArray['perm']['module_dir']['name'] = l('\'modules\' directory and sub-directories must be writable');
$testArray['perm']['module_dir']['res'] = is_writable(dirname(__FILE__).'/../../modules/');
$testArray['perm']['tools_dir']['name'] = l('\'tools/smarty/compile\' directory must be writable');
$testArray['perm']['tools_dir']['res'] = is_writable(dirname(__FILE__).'/../../tools/smarty/compile');

$testArray['error']['img_bad'] = '<img src="../img/install/bad.gif" alt="'.l('Bad').'" />';
$testArray['perm']['img_bad'] = '<img src="../img/install/bad.gif" alt="'.l('Bad').'" />';


$errors = array('perm' => 0, 'warn' => 0, 'error' => 0);
$content .= '<h2>'.l('Required configuration').'</h2>
<table cellspacing="0" class="table">';
$i = 1;
foreach ($testArray AS $type => $test)
	foreach ($test AS $k => $value)
		if ($k != 'img_bad')
		{
			$content .= '
			<tr style="background: '.($i++ % 2 ? '#FBF8EB;' : '#FFF').';">
				<td>  </td>
				<th>'.$value['name'].'</th>
				<td>'.($value['res'] ? '<img src="../img/install/ok.gif" alt="OK" />' : $test['img_bad']).'</td>
			</tr>';
			$errors[$type] += !$value['res'];
		}
$content .= '</table>
<br /><h2>'.l('Optional configuration').'</h2>
<table cellspacing="0" class="table">';

$testArrayOpt['warn']['register_globals']['name'] = l('Register globals should be turned off');
$testArrayOpt['warn']['register_globals']['res'] = !ini_get('register_globals');
$testArrayOpt['warn']['gz_compression']['name'] = l('Gzip compression should be enabled');
$testArrayOpt['warn']['gz_compression']['res'] = ini_get('output_handler') OR ini_get('zlib.output_handler');
$testArrayOpt['warn']['img_bad'] = '<img src="../img/install/bad.gif" alt="'.l('Warning').'" />';

$i = 1;
foreach ($testArrayOpt AS $type => $test)
	foreach ($test AS $k => $value)
		if ($k != 'img_bad')
		{
			$content .= '
			<tr style="background: '.($i++ % 2 ? '#FBF8EB;' : '#FFF').';">
				<td> </td>
				<th>'.$value['name'].'</th>
				<td>'.($value['res'] ? '<img src="../img/install/ok.gif" alt="OK" />' : $test['img_bad']).'</td>
			</tr>';
			$errors[$type] += !$value['res'];
		}
$content .= '</table><br />';

if ($errors['error'] OR $errors['perm'])
	$content .= l('You should correct these errors before getting to step 2 !').'<a href="?step=2&id_lang='.$id_lang.'"><br />'.l('Refresh this page').'</a> '.l('when it\'s done.');
else
	$content .= '<img src="../img/install/icon-checksm_g.gif" style="margin-left: 15px;"><span style="margin-left: 10px;">'.l('Everything\'s ok !').'</span><br /><br /><br />
	<a href="?step=3&id_lang='.$id_lang.'"><img src="'.i('btn-step.gif').'" /></a>';

?>