<?php

include('../classes/Validate.php');

$databases = array();
$databases[1]['name'] = 'MySQL';
$databases[1]['available'] = function_exists('mysql_connect');
$databases[2]['name'] = 'PostgreSQL';
$databases[2]['available'] = function_exists('pg_connect');
$imgOk = '<img src="../img/install/ok.gif" alt="OK" />';
$imgBad = '<img src="../img/install/bad.gif" alt="'.l('Bad').'" />';
global $content;

function query_utf8($query) { return mysql_query(utf8_encode($query)); }

if (isset($_POST['Submit']) OR isset($_POST['Submit_x']) OR isset($_POST['Submit_y']))
{
	$errors = array();

	$_POST = array_map('trim', $_POST);
	if (isset($_POST['prefix']) AND !eregi('^[a-z0-9_]*$', $_POST['prefix']))
		$errors[] = l('Enter a correct prefix please.');

	if (!isset($_POST['server']) OR empty($_POST['server']))
		$errors[] = l('Server is required.');
	elseif (!Validate::isMailName($_POST['server']))
		$errors[] = l('Enter a correct server name please.');
	elseif (!isset($_POST['type']) OR empty($_POST['type']))
		$errors[] = l('Type is required.');
	elseif (!Validate::isMailName($_POST['type']))
		$errors[] = l('Enter a correct server type please.');
	elseif (!isset($_POST['name']) OR empty($_POST['name']))
		$errors[] = l('Database name is required.');
	elseif (!Validate::isMailName($_POST['name']))
		$errors[] = l('Enter a correct database name please.');
	elseif (!isset($_POST['user']) OR empty($_POST['user']))
		$errors[] = l('Username is required.');
	elseif (!Validate::isMailName($_POST['user']))
		$errors[] = l('Enter a correct user name please.');
	elseif (!isset($_POST['passwd']))
		$errors[] = l('Password is required.');
	elseif (!isset($_POST['mode']))
		$errors[] = l('Installation mode is required.');
	else
	{
		switch ($_POST['type'])
		{
			case 1 :
				connectMySQL($_POST['server'], $_POST['user'], $_POST['passwd'], $_POST['name']);
				if (!sizeof($errors))
				{
					if (createDB())
					{	
						generateSettings();
						include_once(dirname(__FILE__).'/../../config/settings.inc.php');
						fillSettings('db_settings_lite.sql');
						if ($_POST['mode'] == 'full')
							fillSettings('db_settings_extends.sql');
						mysql_close();
						if (!sizeof($errors))
							redirect(4);
					}
					else
						$errors[] = l('A problem occurred while creating database.');
				}
				break;
			default:
				$errors[] = l('Wrong database type');
		}
	}
	displayErrors();
}
else
{
	$content .= '
	<center>
		<div id="waiting">
			'.l('Creating database... ').'<img src="../img/install/load.gif" />
		</div>
	</center>
	'.l('Potential databases detected on your local server : ').'<br />
	<table cellspacing="0" cellpadding="0" class="table" style="width: 200px; margin-top: 8px; ">';
  	$i = 1;
	foreach($databases AS $database)
		$content .= '<tr style="background: '.($i++ % 2 ? '#FBF8EB;' : '#FFF').';">
						<td style="text-align: left; padding-left: 10px;">'.$database['name'].'</td>
						<td style="width: 30px;">'.($database['available'] ? $imgOk : $imgBad).'</td>
					</tr>';
	$content .= '</table>'.displayForm();
}

function createDB()
{
	global $errors;
	
	$sql_file = dirname(__FILE__).'/db.sql';
	
	if (file_exists($sql_file)) {
		$fd = fopen($sql_file, 'rb');
		$file_content = fread($fd, filesize($sql_file));
		fclose($fd);
	} else {
		$errors[] = l('SQL file does not exist: ').$sql_file;
		return false;
	}
	
	if (!query_utf8('DESCRIBE `'.strtolower($_POST['prefix']).'accessory`'))
	{
		$file_content = str_replace('CREATE TABLE ', 'CREATE TABLE '.strtolower($_POST['prefix']), $file_content);
		
		$arraySQL = split(';', $file_content);
		foreach ($arraySQL as $query)
		{
			$query = trim($query);
			if (!empty($query))
				if (!query_utf8($query))
					$errors[] = l('Invalid request while creating database : ').'<br /><b>'.$query.'</b>';
		}
		if (!query_utf8('ALTER DATABASE `'.$_POST['name'].'` DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci'))
			$errors[] = l('Impossible to change ').$_POST['name'].l(' in unicode');

		$result = query_utf8('SHOW TABLES');
		while ($row = mysql_fetch_assoc($result))
			if (!query_utf8('ALTER TABLE `'.$row['Tables_in_'.$_POST['name']].'` ENGINE = MYISAM'))
				$errors[] = l('Impossible to change ').$row['Tables_in_'.$_POST['name']].l(' engine to MyISAM');
		
		return true;
	}
	else
		$errors[] = l('PS database is already filled, please drop it, and then refresh this page to continue the installation. Otherwise, if you want to keep your existing database, you just have to change your tables prefix in the field below.');
}

function fillSettings($filerq)
{
	global $errors;
	
	if (!($db_settings = file_get_contents(dirname(__FILE__).'/'.$filerq)))
	{
		$errors[] = l('Can\'t get file \''.$filerq.'\' content');
		displayErrors();
		return ;
	}
	$db_settings = str_replace('PREFIX_', _DB_PREFIX_, $db_settings);
	$arraySQL = split(');', $db_settings);
	foreach ($arraySQL as $query)
	{
		$query = trim($query);
		if (!empty($query))
			if (!query_utf8($query.')'))
				$errors[] = l('Invalid request while inserting into database : ').'<br /><b>'.$query.'</b>';
	}
}

function generateSettings()
{
	global $errors, $databases;
	
	include(dirname(__FILE__).'/../../classes/Tools.php');
	
	$settings = '../config/settings.inc.php';
	$csettings = '<?php
	
define(\'_DB_SERVER_\', \''.installSQL($_POST['server']).'\');
define(\'_DB_TYPE_\', \''.installSQL($databases[$_POST['type']]['name']).'\');
define(\'_DB_NAME_\', \''.installSQL($_POST['name']).'\');
define(\'_DB_USER_\', \''.installSQL($_POST['user']).'\');
define(\'_DB_PASSWD_\', \''.installSQL($_POST['passwd']).'\');
define(\'_DB_PREFIX_\', \''.installSQL($_POST['prefix']).'\');
define(\'__PS_BASE_URI__\', \''.substr($_SERVER['REQUEST_URI'], 0, -1 * (strlen($_SERVER['REQUEST_URI']) - strrpos($_SERVER['REQUEST_URI'], '/')) - 8).'/\');
define(\'_THEME_NAME_\', \'default\');
define(\'_COOKIE_KEY_\', \''.Tools::passwdGen(56).'\');
define(\'_COOKIE_IV_\', \''.Tools::passwdGen(8).'\');
define(\'_PS_CREATION_DATE_\', \''.date('Y-m-d').'\');
define(\'_PS_VERSION_\', \''.INSTALL_VERSION.'\');

?>';

	if (!$fd = fopen($settings, 'w'))
		$errors[] = l('Can\'t create settings file, please create a file named settings.inc.php in config directory and paste this content :').'<br />'.$csettings;
	if (!is_writable($settings)) 
	{
		$errors[] = l('Can\'t write in settings file, please create a file named settings.inc.php in config directory and paste this content :').'<br />'.$csettings;
		return false;
	}
	if (!get_magic_quotes_gpc())
		foreach ($_POST as $k => $value)
			$_POST[$k] = installSQL($value);

	if (!fwrite($fd, $csettings))
		$errors[] = l('Can\'t write in settings file, please fill up the file named settings.inc.php in config directory and paste this content :').'<br />'.$csettings;
	fclose($fd);
}

function displayForm()																
{
	global $databases, $currentStep, $id_lang;

	$form = l('Fill your database settings below :').'<br />
	<form name="form" id="form" action="?step=3&id_lang='.$id_lang.'" method="post" '.(file_exists('../config/settings.inc.php') ? 
	'onsubmit="return confirm(\''.l('The file \\\'settings.inc.php\\\' already exists. Are you sure you want to write over it?').'\');' : 
	'').
	'document.getElementById(\'waiting\').style.display = \'block\';">
	<table class="form-table">
		<tr>
			<th>'.l('Server').'</th>
			<td>
				<input type="text" name="server" value="'.stripslashes(isset($_POST['server']) ? $_POST['server'] : 'localhost').'" /><span id="required"> *</span>
				<p class="note">'.l('Enter server name (commonly \'localhost\')').'</p>
			</td>
		</tr>
		<tr>
			<th>'.l('Database type').'</th>
			<td>
				<select name="type">';
	
	foreach ($databases AS $value => $database) {
		if ($database['name'] == 'MySQL')
			$form .= '<option value="'.$value.'">'.$database['name'].'</option>';
	}
	$form .= '	</select>
				<span id="required"> *</span>
				<p class="note">'.l('Select your database type').'</p>
			</td>
		</tr>
		<tr>
			<th>'.l('Database name').'</th>
			<td>
				<input type="text" name="name" value="'.stripslashes(isset($_POST['name']) ? $_POST['name'] : '').'" /><span id="required"> *</span>
				<p class="note">'.l('Enter database name').'</p>
			</td>
		</tr>
		<tr>
			<th>'.l('Table prefix').'</th>
			<td>
				<input type="text" name="prefix" value="'.stripslashes(strtolower((isset($_POST['prefix']) ? $_POST['prefix'] : 'ps_'))).'" />
				<p class="note">'.l('You should specify a prefix like ps_').'</p>
			</td>
		</tr>
		<tr>
			<th>'.l('Username').'</th>
			<td>
				<input type="text" name="user" value="'.stripslashes(isset($_POST['user']) ? $_POST['user'] : '').'" /><span id="required"> *</span>
				<p class="note">'.l('Your name to enter your database(eg. John Doe)').'</p>
			</td>
		</tr>
		<tr>
			<th>'.l('Password').'</th>																																
			<td width="500px">
				<input type="password" name="passwd" value="'.stripslashes(isset($_POST['passwd']) ? $_POST['passwd'] : '').'" />
				<span id="required"> *</span>
				<img src="../img/install/eye.gif" onclick="
					var reveal = document.getElementById(\'reveal\');
					var pass = document.form.passwd.value;
					if (reveal.innerHTML == pass)
					{
						reveal.style.border = \'1px solid #FFFFFF\';
						reveal.style.backgroundColor = \'#FFFFFF\';
						reveal.innerHTML = \'\';
					}
					else
					{
						reveal.style.backgroundColor = \'#F9E3EE\';
						reveal.style.border = \'1px dashed #C73178\';
						reveal.innerHTML = pass;
					}
					" /> <span id="reveal" class="reveal"></span>
				<p class="note">'.l('Your password to enter your database').'</p>
			</td>
		</tr>
		<tr>
			<th>'.l('Mode').'</th>
			<td>
				<input type="radio" value="full" name="mode" checked="checked" /> '.l('Complete').'<br />
				<p class="note">'.l('Install most-used modules and give somes categorys/products samples in order to test the software.').'</p>
				<br />
				<input type="radio" value="lite" name="mode" /> '.l('Lite').'<br />
				<p class="note">'.l('None installed modules nor of products samples.').'</p>
			</td>
		</tr>
	</table>
	<br /><span id="required" style="font-weight: normal;">* '.l('Required fields').'</span><br />
	<input type="hidden" name="step" value="'.$currentStep.'" /><br />
	<input type="image" name="Submit" value="'.l('Create').'" src="'.i('btn-db.gif').'" />
	</form>';
	
	return $form;
}

?>