<?php

class BlockBestSellers extends Module
{
    private $_html = '';
    private $_directory;
    private $_filename;
    private $_filename_http;
    private $_postErrors = array();
    
    function __construct()
    {
        $this->name = 'blockbestsellers';
        $this->tab = 'Blocks';
        $this->version = 0.8;
		
		$this->_translations = array(
			'FR' => array(
				'Block best sellers' => 'Bloc meilleures ventes',
				'Shows best sellers in your shop right column' => 'Affiche un aper&ccedil;u des meilleures ventes du moment dans la colonne droite de votre boutique',
				'Best sellers' => 'Meilleures ventes', 
				'All best sellers...' => 'Toutes les meilleures ventes', 
				'No new best sellers' => 'Pas de nouvelles meilleures ventes', 
				'at this time' => 'pour le moment'
			)
		);

        parent::__construct();
        
        /* The parent construct is required for translations */
        $this->displayName = $this->l('Block best sellers');
        $this->description = $this->l('Shows best sellers in your shop right column');
    }

    function install()
    {
        parent::install();
        $this->registerHook('rightColumn');
    }
    
    function hookRightColumn($params)
    {				
     	$output = '
		<!-- Block best sellers -->
		<div class="block_title">
			<a href="best-sales.php"><img src="'.$this->_path.'logo.gif" alt="'.$this->l('Best sellers').'" title="'.$this->l('Best sellers').'" /></a> 
			<a href="best-sales.php">'.$this->l('Best sellers').'</a>
		</div>
		<div class="block">';
		
		$best_sellers = Product::getBestSalesLight(intval($params['cookie']->id_lang), 0, 5);
		if ($best_sellers)
		{
		 	$output .='
			<div class="block_img">
				<a href="'.$best_sellers[0]['link'].'"><img src="'._THEME_PROD_DIR_.$best_sellers[0]['id_image'].'-medium.jpg" 
				alt="'.$best_sellers[0]['legend'].'" title="'.$best_sellers[0]['legend'].'" /></a>
			</div>';

			$output .= '<ol>';
			foreach ($best_sellers AS $best_seller)
				$output .= '<li><a href="'.$best_seller['link'].'">'.$best_seller['name'].'</a></li>';
			$output .= '</ol>';
			
			$output .= '
			<div class="block_content_end">
				<a href="'.__PS_BASE_URI__.'best-sales.php">'.$this->l('All best sellers...').'</a>
			</div>';
		}
		else
			$output .= '
			<div class="center tspace bspace">'.$this->l('No new best sellers').'<br />'.$this->l('at this time').'</div>
			<div class="block_content_end"></div>';
		
		$output .= '			
		</div>
		<div class="block_footer"></div>
		<!-- /Block best sellers -->';
		
		return $output;
	}
}


?>
