<?php

class BlockViewed extends Module
{
    private $_html = '';
    private $_directory;
    private $_filename;
    private $_filename_http;
    private $_postErrors = array();
    
    function __construct()
    {
     	$this->name = 'blockviewed';
     	$this->tab = 'Blocks';
        $this->version = 0.8;
	 	$this->_translations = array(
			'FR' => array(
				'Block viewed products' => 'Bloc produits d&eacute;j&agrave; vus',
				'Shows last viewed products' => 'Affiche les derniers produits vus', 
				'Viewed products' => 'D&eacute;j&agrave; vus'
			)
		);

        parent::__construct();
		
		/* The parent construct is required for translations */
        $this->displayName = $this->l('Block viewed products');
        $this->description = $this->l('Shows last viewed products');
        
    }

    function install()
    {
        parent::install();
        $this->registerHook('rightColumn');
    }
    
    function hookRightColumn($params)
	{
		global $link;
		if (!get_class($link) == 'Link')
			die (Tools::displayError());
		if (!($id_product = intval(Tools::getValue('id_product'))) OR !Validate::isLoadedObject($product = new Product($id_product)))
			return false;
		$productsViewed = (isset($params['cookie']->viewed) AND !empty($params['cookie']->viewed)) ? array_slice(explode(',', $params['cookie']->viewed), 0, 2) : array();
		if (sizeof($productsViewed))
		{
			$productsViewedObj = array();
			foreach ($productsViewed AS $productViewed)
			{
				$obj = new Product(intval($productViewed), false, intval($params['cookie']->id_lang));
				if (!Validate::isLoadedObject($obj))
					continue;
				else
				{
					$images = $obj->getImages(intval($params['cookie']->id_lang));
					foreach ($images AS $k => $image)
						if ($image['cover'])
						{
							$obj->cover = $obj->id.'-'.$image['id_image'];
							$obj->legend = $image['legend'];
							break;
						}
					if (!isset($obj->cover))
					{
						$obj->cover = 'default';
						$obj->legend = '';
					}
					$productsViewedObj[] = $obj;
				}
			}
			if (!in_array($product->id, $productsViewed))
				array_unshift($productsViewed, $product->id);
			$viewed = '';
			foreach ($productsViewed AS $id_product_viewed)
				$viewed .= intval($id_product_viewed).',';
			$params['cookie']->viewed = rtrim($viewed, ',');

			if (sizeof($productsViewedObj))
			{
				$output = '
				<div class="block_title">
					<img src="'.$this->_path.'logo.gif" alt="'.$this->l('Viewed products').'" title="'.$this->l('Viewed products').'" /> '.$this->l('Viewed products').'
				</div>
				<div class="block">
					<table style="margin: 4px">';
				foreach ($productsViewedObj AS $viewedProduct)
					$output .= '
						<tr>
							<td><a href="'.$link->getProductLink($viewedProduct).'">
								<img src="'._THEME_PROD_DIR_.$viewedProduct->cover.'-small.jpg" alt="'.$viewedProduct->legend.'" title="'.$viewedProduct->legend.'" /> 
							</a></td>
							<td><a href="'.$link->getProductLink($viewedProduct).'">
								'.$viewedProduct->name.'
							</a></td>
						</tr>';
				$output .= '
					</table>
					<div class="block_content_end"></div>
				</div>
				<div class="block_footer"></div>';
				return $output;
			}
		}
		return false;
	}
}


?>
