<?php

class HomeFeatured extends Module
{
    private $_html = '';
    private $_directory;
    private $_filename;
    private $_filename_http;
    private $_postErrors = array();
    
    function __construct()
    {
        $this->name = 'homefeatured';
        $this->tab = '';
        $this->version = 0.8;
		
		$this->_translations = array(
			'FR' => array(
				'Home featured products' => 'Produits phares',
				'Shows products in your home page' => 'Module affichant les produits au centre de votre page d\'accueil', 
				'FEATURED PRODUCTS' => 'SELECTION',
				'Cart' => 'Panier',
				'No products' => 'Aucun produit',
				'Total' => 'Total',
				'Checkout' => 'Commander',
				'My cart' => 'Panier'
			)
		);

        parent::__construct();
        
        /* The parent construct is required for translations */
        $this->displayName = $this->l('Home featured products');
        $this->description = $this->l('Shows products in your home page');
    }

    function install()
    {
        parent::install();
        $this->registerHook('home');
    }
    
    function hookHome($params)
    {
     	$link = new Link;
     	$category = new Category(1);
		$products = $category->getProducts(intval($params['cookie']->id_lang), 1, 10);
		$currency = new Currency($params['cart']->id_currency);
		$lang = Language::getIsoById(intval($params['cookie']->id_lang));
     	$productNumber = sizeof($products);
     	
     	$output = '
     	<!-- Home Featured Products module -->
     	<h2 class="content_title">'.$this->l('FEATURED PRODUCTS').'</h2>
			<div class="space">';
		
		if ($products)
		{
			$nbPrd = 0;
			foreach ($products AS $value)
			{
				$productLink = $link->getProductLink($value['id_product'], $value['link_rewrite']);
				$productName = $value['name'].(isset($value['attributes_small']) ? ' '.$value['attributes_small'] : '');
				
				if ($nbPrd % 4 == 0)
				{
					$output .= '<div class="space">';
				}
				
				$output .= '
				<div class="featured_product">
					<a href="'.$productLink.'">
						<img src="'._THEME_PROD_DIR_.$value['id_image'].'-medium.jpg" alt="'.$value['legend'].'" title="'.$value['legend'].'" class="product_image bspace" />
					</a>
					<h2 class="product_name">
						<a href="'.$productLink.'" class="product_link">
							'.$productName.'
						</a>
					</h2>
					<span class="price">'.Tools::displayPrice($value['price'], $currency).'</span>
					<br />
							
							<!-- View Button-->
							<a href="'.$productLink.'">
								<img src="'._THEME_IMG_DIR_.$lang.'/btn-view.gif" alt="View" title="Add to cart" class="tspace" />
							</a>
							
							<!-- Add to cart Button -->
							<a href="'.__PS_BASE_URI__.'cart.php?qty=1&amp;id_product='.$value['id_product'].'&amp;add">
								<img src="'._THEME_IMG_DIR_.$lang.'/btn-add.gif" alt="Add to cart" title="Add to cart" class="add_to_cart_btn" />
							</a>
						</div>
						
						<!-- Dashed separation -->';

				$nbPrd++;

				if ($nbPrd % 4 != 0)
				{
					$output .= '<div class="featured_sep"></div>';
				}

				

				$output .= '	<!-- Line separation -->';

				if ($nbPrd % 4 == 0 || $nbPrd == $productNumber)
				{
					$output .= '<!-- Clear -->
						<div class="clear featured_line"></div>
					</div>';
				}
			}			
		}
		$output .= '</div>';
		
		return $output;
	}
}


?>
